/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the FacebookVideoConnectorFormAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &FacebookVideoConnectorFormAllOf{}

// FacebookVideoConnectorFormAllOf struct for FacebookVideoConnectorFormAllOf
type FacebookVideoConnectorFormAllOf struct {
	// Authorizer ID
	OAuthId *string `json:"oAuthId,omitempty"`
	// Label of the source
	Label *string `json:"label,omitempty"`
	// Facebook Page ID.
	PageId *string `json:"pageId,omitempty"`
	// Metrics
	Metric []string `json:"metric,omitempty"`
	// Data labels
	DataLabel []string `json:"dataLabel,omitempty"`
	// Max videos returned
	Limit *int32 `json:"limit,omitempty"`
}

// NewFacebookVideoConnectorFormAllOf instantiates a new FacebookVideoConnectorFormAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewFacebookVideoConnectorFormAllOf() *FacebookVideoConnectorFormAllOf {
	this := FacebookVideoConnectorFormAllOf{}
	var limit int32 = 100
	this.Limit = &limit
	return &this
}

// NewFacebookVideoConnectorFormAllOfWithDefaults instantiates a new FacebookVideoConnectorFormAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewFacebookVideoConnectorFormAllOfWithDefaults() *FacebookVideoConnectorFormAllOf {
	this := FacebookVideoConnectorFormAllOf{}
	var limit int32 = 100
	this.Limit = &limit
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *FacebookVideoConnectorFormAllOf) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookVideoConnectorFormAllOf) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *FacebookVideoConnectorFormAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *FacebookVideoConnectorFormAllOf) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *FacebookVideoConnectorFormAllOf) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookVideoConnectorFormAllOf) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *FacebookVideoConnectorFormAllOf) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *FacebookVideoConnectorFormAllOf) SetLabel(v string) {
	o.Label = &v
}

// GetPageId returns the PageId field value if set, zero value otherwise.
func (o *FacebookVideoConnectorFormAllOf) GetPageId() string {
	if o == nil || IsNil(o.PageId) {
		var ret string
		return ret
	}
	return *o.PageId
}

// GetPageIdOk returns a tuple with the PageId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookVideoConnectorFormAllOf) GetPageIdOk() (*string, bool) {
	if o == nil || IsNil(o.PageId) {
		return nil, false
	}
	return o.PageId, true
}

// HasPageId returns a boolean if a field has been set.
func (o *FacebookVideoConnectorFormAllOf) HasPageId() bool {
	if o != nil && !IsNil(o.PageId) {
		return true
	}

	return false
}

// SetPageId gets a reference to the given string and assigns it to the PageId field.
func (o *FacebookVideoConnectorFormAllOf) SetPageId(v string) {
	o.PageId = &v
}

// GetMetric returns the Metric field value if set, zero value otherwise.
func (o *FacebookVideoConnectorFormAllOf) GetMetric() []string {
	if o == nil || IsNil(o.Metric) {
		var ret []string
		return ret
	}
	return o.Metric
}

// GetMetricOk returns a tuple with the Metric field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookVideoConnectorFormAllOf) GetMetricOk() ([]string, bool) {
	if o == nil || IsNil(o.Metric) {
		return nil, false
	}
	return o.Metric, true
}

// HasMetric returns a boolean if a field has been set.
func (o *FacebookVideoConnectorFormAllOf) HasMetric() bool {
	if o != nil && !IsNil(o.Metric) {
		return true
	}

	return false
}

// SetMetric gets a reference to the given []string and assigns it to the Metric field.
func (o *FacebookVideoConnectorFormAllOf) SetMetric(v []string) {
	o.Metric = v
}

// GetDataLabel returns the DataLabel field value if set, zero value otherwise.
func (o *FacebookVideoConnectorFormAllOf) GetDataLabel() []string {
	if o == nil || IsNil(o.DataLabel) {
		var ret []string
		return ret
	}
	return o.DataLabel
}

// GetDataLabelOk returns a tuple with the DataLabel field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookVideoConnectorFormAllOf) GetDataLabelOk() ([]string, bool) {
	if o == nil || IsNil(o.DataLabel) {
		return nil, false
	}
	return o.DataLabel, true
}

// HasDataLabel returns a boolean if a field has been set.
func (o *FacebookVideoConnectorFormAllOf) HasDataLabel() bool {
	if o != nil && !IsNil(o.DataLabel) {
		return true
	}

	return false
}

// SetDataLabel gets a reference to the given []string and assigns it to the DataLabel field.
func (o *FacebookVideoConnectorFormAllOf) SetDataLabel(v []string) {
	o.DataLabel = v
}

// GetLimit returns the Limit field value if set, zero value otherwise.
func (o *FacebookVideoConnectorFormAllOf) GetLimit() int32 {
	if o == nil || IsNil(o.Limit) {
		var ret int32
		return ret
	}
	return *o.Limit
}

// GetLimitOk returns a tuple with the Limit field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *FacebookVideoConnectorFormAllOf) GetLimitOk() (*int32, bool) {
	if o == nil || IsNil(o.Limit) {
		return nil, false
	}
	return o.Limit, true
}

// HasLimit returns a boolean if a field has been set.
func (o *FacebookVideoConnectorFormAllOf) HasLimit() bool {
	if o != nil && !IsNil(o.Limit) {
		return true
	}

	return false
}

// SetLimit gets a reference to the given int32 and assigns it to the Limit field.
func (o *FacebookVideoConnectorFormAllOf) SetLimit(v int32) {
	o.Limit = &v
}

func (o FacebookVideoConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o FacebookVideoConnectorFormAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.PageId) {
		toSerialize["pageId"] = o.PageId
	}
	if !IsNil(o.Metric) {
		toSerialize["metric"] = o.Metric
	}
	if !IsNil(o.DataLabel) {
		toSerialize["dataLabel"] = o.DataLabel
	}
	if !IsNil(o.Limit) {
		toSerialize["limit"] = o.Limit
	}
	return toSerialize, nil
}

type NullableFacebookVideoConnectorFormAllOf struct {
	value *FacebookVideoConnectorFormAllOf
	isSet bool
}

func (v NullableFacebookVideoConnectorFormAllOf) Get() *FacebookVideoConnectorFormAllOf {
	return v.value
}

func (v *NullableFacebookVideoConnectorFormAllOf) Set(val *FacebookVideoConnectorFormAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableFacebookVideoConnectorFormAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableFacebookVideoConnectorFormAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFacebookVideoConnectorFormAllOf(val *FacebookVideoConnectorFormAllOf) *NullableFacebookVideoConnectorFormAllOf {
	return &NullableFacebookVideoConnectorFormAllOf{value: val, isSet: true}
}

func (v NullableFacebookVideoConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFacebookVideoConnectorFormAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
